﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace XamDataTree
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DepartmentList oDepartments = new DepartmentList();
            oDepartments.Add(new Department() { ID = 1, ParentID = 0, Name = "Department A", SubDepartments = new DepartmentList() });
            oDepartments.Add(new Department() { ID = 2, ParentID = 0, Name = "Department B", SubDepartments = new DepartmentList() });
            oDepartments.Add(new Department() { ID = 3, ParentID = 0, Name = "Department C", SubDepartments = new DepartmentList() });

            oDepartments[0].SubDepartments.Add(new Department() { ID = 4, ParentID = 1, Name = "Sub-Department 1", SubDepartments = new DepartmentList() });
            oDepartments[0].SubDepartments.Add(new Department() { ID = 5, ParentID = 1, Name = "Sub-Department 2", SubDepartments = new DepartmentList() });
            oDepartments[0].SubDepartments.Add(new Department() { ID = 6, ParentID = 1, Name = "Sub-Department 3", SubDepartments = new DepartmentList() });

            oDepartments[0].SubDepartments[0].SubDepartments.Add(new Department() { ID = 7, ParentID = 6, Name = "Sub-Sub-Department 3A" });
            oDepartments[0].SubDepartments[0].SubDepartments.Add(new Department() { ID = 8, ParentID = 6, Name = "Sub-Sub-Department 3B" });

            xamDataTree1.ItemsSource = oDepartments;
        }
    }

    public class DepartmentList : ObservableCollection<Department>
    {
        
    }


    public class Department
    {

        private int _ID;
        private int _parentID;
        private string _name;
        private DepartmentList _subDepts;
        
        public int ID
        {
            get { return _ID; }
            set
            {
                _ID = value;

            }
        }

        public int ParentID
        {
            get { return _parentID; }
            set
            {
                _parentID = value;

            }
        }

        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;

            }
        }

        public DepartmentList SubDepartments
        {
            get { return _subDepts; }
            set
            {
                _subDepts = value;
                
            }
        }

        public override string ToString()
        {
            return _name;
        }
    }
}
